#include <iostream>
#include <cstdlib>
#include <cmath>
#include <omp.h>
#include <utility>
#include <unistd.h>

using namespace std;

void doParallelWork(){
  cout << "Entered doParallelWork function" << std::endl; 
  #pragma omp parallel default(shared)  
  {
    unsigned int thread_count = omp_get_num_threads();
    unsigned int thread_num = omp_get_thread_num();
    if (thread_num == 0 ) {
      cout << "This program uses " << thread_count << " threads.\n" << std::flush;
      cout << "Second Master Only cout " << std::endl;
      cout << "Third Master Only cout " << std::endl;
    } else {
      for (long int j=0;j<1000;j++){
	cout << "NonMasterThread " << thread_num << " reporting at iteration " << j << std::endl;
        for (long int i=0;i< 1000;i++) {
          sqrt(i);
	}
      }	
    }
    cout << "This is thread #" << thread_num << " before the barrier.\n";
    #pragma omp barrier
    cout << "This is thread #" << thread_num << " after the barrier.\n";
    #pragma omp master 
    cout << std::flush;
  }
}

int main(int argc, char *argv[]) {
  double const t0 = omp_get_wtime();

  doParallelWork();


  double const t1 = omp_get_wtime();
  cout << "Time: " << t1 - t0 << " s\n";
}
